#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#include <tigcclib.h>         // Include All Header Files


#define SIZE 36

// Main Function

void _main(void)
{
	static short int A[SIZE+1][SIZE+1]; //create a SIZE by SIZE "matrix" (array of arrays)
	static short int B[SIZE+1][SIZE+1];
	int s = 0;
	int n = 0;
	int x = 0;
	int y = 0;
	int xx = 18;
	int yy = 18;
	int key = 0;
	
	void *screen = malloc(LCD_SIZE);
	if (screen == NULL)
	{
		ST_helpMsg("Out of memory");
		exit(0);
	}
	memcpy(screen, LCD_MEM, LCD_SIZE);
	
	for(y=0;y<100;y++){
		for(x=0;x<160;x++){
			DrawPix(x,y,A_NORMAL);  //make the whole screen black
		}
	}
	DrawStr(5,78,"Use arrow keys to move   ",A_XOR);
 	DrawStr(5,86,"& press F1 to place a dot",A_XOR);
 	
 	FontSetSys(F_8x10);  
	DrawStr(76,04,"Game",A_XOR);
	DrawStr(76,14,"    of",A_XOR);
	DrawStr(76,24,"      Life",A_XOR);
	FontSetSys(F_4x6);
	DrawStr(75,24,"run",A_XOR);
	DrawStr(90,34,"By Scott Little",A_XOR);
	DrawStr(73,42,"Modified by sunjayc_99",A_XOR);
	DrawStr(73,48,"F2 to remove a dot and",A_XOR);
	DrawStr(73,54,"F3 to switch between",A_XOR);
	DrawStr(73,60,"input and run modes",A_XOR);
	DrawStr(73,66,"F4 to randomize the grid",A_XOR);
	DrawStr(73,72,"F5 to clear the grid",A_XOR);
	/*
	for(y = 1; y < SIZE; y++)
	{
		for(x = 1; x < SIZE; x++)
		{
			A[y][x] = 0;
		}
	}
	*/
	memset(A, 0, ((SIZE+1) * (SIZE+1)) * sizeof(short));
	input:
	DrawStr(75,24,"run",A_XOR);			// Erase the "run" message
	DrawStr(75,24,"input",A_XOR);		// Draw the "input" message
	while (key!=KEY_ESC && key != KEY_F3){  //the input loop of the program
		if (kbhit()){									//key controls
			key = ngetchx();
			if (key==KEY_UP && yy > 1)(yy--);          
			if (key==KEY_DOWN && yy < SIZE-1)(yy++);
			if (key==KEY_RIGHT && xx < SIZE-1)(xx++);
			if (key==KEY_LEFT && xx > 1)(xx--);
			if (key==KEY_F1)(A[yy][xx]=1);
			if (key==KEY_F2)(A[yy][xx]=0);
			if (key==KEY_F4)
			{
				randomize();  //seed the randomizer
				for(y=1;y<SIZE;y++){
					for(x=1;x<SIZE;x++){
						A[y][x] = random(2); //pick either 0 or 1 and put it in A
					}
				}
			}
			if (key==KEY_F5)
			{
				memset(A, 0, ((SIZE+1) * (SIZE+1)) * sizeof(short));
			}
		}

		
		DrawPix(2*xx,2*yy,A_NORMAL);				//these 4 lines draw the cursor dot
		DrawPix(2*xx+1,2*yy,A_NORMAL);
		DrawPix(2*xx,2*yy+1,A_NORMAL);
		DrawPix(2*xx+1,2*yy+1,A_NORMAL);
		
		for(y = 1; y < SIZE; y++)
		{
			for(x = 1; x < SIZE; x++)
			{
				if(A[y][x] == 1)
				{
					DrawPix(2*x,2*y,A_NORMAL);			// Draw a dot
					DrawPix(2*x+1,2*y,A_NORMAL);
					DrawPix(2*x,2*y+1,A_NORMAL);
					DrawPix(2*x+1,2*y+1,A_NORMAL);
				}
				else
				{
					DrawPix(2*x,2*y,A_REVERSE);				// Remove a dot
					DrawPix(2*x+1,2*y,A_REVERSE);
					DrawPix(2*x,2*y+1,A_REVERSE);
					DrawPix(2*x+1,2*y+1,A_REVERSE);
				}
			}
		}
	}
	
	DrawStr(75,24,"input",A_XOR);			// Erase the "input" message
	DrawStr(75,24,"run",A_XOR);				// Draw the "run" message
	while (key!=KEY_ESC){  					//the main loop of the program
		if (kbhit()){									//key controls
			key = ngetchx();
			if (key==KEY_UP && yy > 1)(yy--);          
			if (key==KEY_DOWN && yy < SIZE-1)(yy++);
			if (key==KEY_RIGHT && xx < SIZE-1)(xx++);
			if (key==KEY_LEFT && xx > 1)(xx--);
			if (key==KEY_F1)(A[yy][xx]=1);
			if (key==KEY_F2)(A[yy][xx]=0);
			if (key==KEY_F3)
			{
				key = 0;
				goto input;
			}
			if (key==KEY_F4)
			{
				randomize();  //seed the randomizer
				for(y=1;y<SIZE;y++){
					for(x=1;x<SIZE;x++){
						A[y][x] = random(2); //pick either 0 or 1 and put it in A
					}
				}
			}
			if (key==KEY_F5)
			{
				memset(A, 0, ((SIZE+1) * (SIZE+1)) * sizeof(short));
			}
		} 
		else{
			key = 0;
		}

		
		DrawPix(2*xx,2*yy,A_NORMAL);				//these 4 lines draw the cursor dot
		DrawPix(2*xx+1,2*yy,A_NORMAL);
		DrawPix(2*xx,2*yy+1,A_NORMAL);
		DrawPix(2*xx+1,2*yy+1,A_NORMAL);
		
		for(y = 1; y < SIZE; y++)
		{
			for(x = 1; x < SIZE; x++)
			{
				n = A[y][x];
				s = A[y-1][x-1]+A[y-1][x]+A[y-1][x+1]+A[y][x-1]+A[y][x+1]+A[y+1][x-1]+A[y+1][x]+A[y+1][x+1];
				B[y][x] = 0;
				if((n == 1 && s == 2) || s == 3)
				{
					B[y][x] = 1;
				}
			}
		}
		
		for(y=1;y<SIZE;y++){                   //these 2 for loops draw either a dot or a nondot
			for(x=1;x<SIZE;x++){
				if (B[y][x]==1){
					DrawPix(2*x,2*y,A_NORMAL);     //these 4 lines draw one dot
					DrawPix(2*x+1,2*y,A_NORMAL);
					DrawPix(2*x,2*y+1,A_NORMAL);
					DrawPix(2*x+1,2*y+1,A_NORMAL);
					
				}
				else {
					DrawPix(2*x,2*y,A_REVERSE);  //these 4 lines erase one dot
					DrawPix(2*x+1,2*y,A_REVERSE);
					DrawPix(2*x,2*y+1,A_REVERSE);
					DrawPix(2*x+1,2*y+1,A_REVERSE);
				}
				A[y][x] = B[y][x];  //transfer the contents of B into A, so A can be edited
			}
		}
		
	}
	memcpy(LCD_MEM, screen, LCD_SIZE);
	ST_helpMsg("GAMELIF2 v2.0 by sunjayc_99");
  free(screen);
}
